#include <stdio.h>
#include <string.h>
#include <sys/stat.h>
#include "scsipart.h"


void print_guide(char* str, int sectcnt)
{
  int i = (sectcnt*LOGSEC_LEN + (RWSIZ-1))/RWSIZ;

  printf("%s \x1b[s", str);
  while (--i >= 0) fputc('.', stdout);
  printf("\x1b[u");
  fflush(stdout);
}


static int file_copy(FILE* fp, int id, int offset, int sectcnt)
{
  int    cnt  = RWSIZ/LOGSEC_LEN;
  size_t size = RWSIZ;

  while (sectcnt > 0) {
    if (fp) {
      if ((size = fread(rwbuf, sizeof(char), RWSIZ, fp)) <= 0) break;
      size = (size + (LOGSEC_LEN-1)) & ~(LOGSEC_LEN-1);
    }
    if (scsi_writeext(id, rwbuf, offset, min(RWSIZ, size)/LOGSEC_LEN) < 0) {
      fprintf(stderr, "ݎs...\n");
      return -1;
    }
    offset  += cnt;
    sectcnt -= cnt;
    fputc('o', stdout), fflush(stdout);
  }
  return 0;
}


void image_put(int id)
{
  int no, size, offset, part_max, yn;
  char*name;
  FILE *fp;
  struct stat st;

  if ((part_max = countpart() - 1) < 0) {
    fprintf(stderr, "̈悪mۂĂ܂\n");
    return;
  }

  no = inputc("C[Wޗ̈(a%c) -->", part_max > 7 ? 'h' : partname(part_max));
  if (no < 'a' || no > (part_max > 7 ? 'h' : partname(part_max)) || no == 'c') {
    fprintf(stderr, "̈w肪sł.\n");
    return;
  }
  no = partnumber(no);

  size = parttab.ent[no].count;
  if (!size) {
    fprintf(stderr, "w肳ꂽ̈͊mۂĂ܂.\n");
    return;
  }
  offset = parttab.ent[no].start;

  name = input("sd%d%c(%dMB) Ƀt@C̓e݂܂.\nt@C͂ĉ -->", id, partname(no), size/1024);
  if (!strlen(name)) return;
  if (!(fp = fopen(name, "rb"))) {
    fprintf(stderr, "t@C %s I[vł܂ł", name);
    return;
  }
  if (fstat(fileno(fp), &st) < 0) {
    fprintf(stderr, "t@C %s ̃TCY擾ł܂ł", name);
    return;
  }
  if (st.st_size != size*LOGSEC_LEN) {
    yn = inputc("C[Wƃp[eBV̑傫Ⴂ܂.\ns܂(y/n)? ");
    if (yn != 'Y' && yn != 'y') {
      printf("~܂\n");
      return;
    }
    size = (st.st_size + (LOGSEC_LEN-1))/LOGSEC_LEN;
  }

  if (scsi_read_capacity(id) == NULL) {
    fprintf(stderr, "ZN^TCY擾ł܂ł.\n");
    return;
  }

  print_guide("ݒ", size);
  if (file_copy(fp, id, offset, size)) return;
  printf(" ݏI.\n");
}


void image_clear(int id)
{
  int no, size, offset, part_max, yn;

  if ((part_max = countpart() - 1) < 0) {
    fprintf(stderr, "̈悪mۂĂ܂\n");
    return;
  }

  no = inputc("NÄ(a%c) -->", part_max > 7 ? 'h' : partname(part_max));
  if (no < 'a' || no > (part_max > 7 ? 'h' : partname(part_max)) || no == 'c') {
    fprintf(stderr, "̈w肪sł.\n");
    return;
  }
  no = partnumber(no);

  size = parttab.ent[no].count;
  if (!size) {
    fprintf(stderr, "w肳ꂽ̈͊mۂĂ܂.\n");
    return;
  }
  offset = parttab.ent[no].start;

  yn = inputc("{ sd%d%c NAĂł(y/n)? ", id, partname(no));
  if (yn != 'Y' && yn != 'y') {
    printf("~܂\n");
    return;
  }

  if (scsi_read_capacity(id) == NULL) {
    fprintf(stderr, "ZN^TCY擾ł܂ł.\n");
    return;
  }

  memset(rwbuf, 0, RWSIZ);
  print_guide("̈NA", size);
  if (file_copy(NULL, id, offset, size)) return;
  printf(" NAI.\n");
}


