#include	<stdio.h>
#include	"scsipart.h"

#ifndef	NULL
#define	NULL	((void*)0)
#endif

int  scsi_sector_type = 1;	/* 512bytes/sector */
int  scsi_sector_count= 2;	/* 2sectors/cluster */

/*{
y֐z
	int	ck_scsi_testunit(int id)

yz
	id	eXg SCSI foCX id

y@\z
	SCSI foCX ready `FbNB

y߂z
	SCSI foCX ready Ȃ 0
	łȂȂ΁A 8bit  scsi sts,  8bit sence key
}*/
int	ck_scsi_testunit(int id)
{
	int	sts;
	char	buffer[8];

	if ((sts = _scsi_testunit(id)) > 0 && (sts & SCSI_STS_CHKCOND)) {
		/*
		 *	check condition ̓G[Xe[^XKv
		 */
		_scsi_request(sizeof buffer, id, (void*)buffer);
		sts |= (buffer[2]&0xf)<<8;		/* sense key ݒ */
	}
	return sts;
}


/*{
y֐z
	int	ck_scsi_inquiry(int inqsiz, int id, struct _inquiry* inqptr)

yz
	id		eXg SCSI foCX id
	inqptr	ǂݍ struct _inquiry ւ̃|C^

y@\z
	SCSI foCX̃ubNEZN^TCY̎擾

y߂z
	SCSI foCX琳ɏ񂪓ǂݍ߂ꍇ 0
	łȂȂ΁A 8bit  scsi sts,  8bit sence key
}*/
int	ck_scsi_inquiry(int inqsiz, int id, struct _inquiry* inqptr)
{
	int	sts;
	char	buffer[8];

	if ((sts = _scsi_inquiry(inqsiz, id, inqptr)) > 0 && (sts & SCSI_STS_CHKCOND)) {
		/*
		 *	check condition ̓G[Xe[^XKv
		 */
		_scsi_request(sizeof buffer, id, (void*)buffer);
		sts |= (buffer[2]&0xf)<<8;		/* sense key ݒ */
	}
	return sts;
}


/*{
y֐z
	int	ck_scsi_readcap(int id, struct _readcap* capptr)

yz
	id		eXg SCSI foCX id
	capptr	ǂݍ struct _readcap ւ̃|C^

y@\z
	SCSI foCX̃ubNEZN^TCY̎擾

y߂z
	SCSI foCX琳ɏ񂪓ǂݍ߂ꍇ 0
	łȂȂ΁A 8bit  scsi sts,  8bit sence key
}*/
int	ck_scsi_readcap(int id, struct _readcap* capptr)
{
	int	sts;
	char	buffer[8];

	if ((sts = _scsi_readcap(id, capptr)) > 0 && (sts & SCSI_STS_CHKCOND)) {
		/*
		 *	check condition ̓G[Xe[^XKv
		 */
		_scsi_request(sizeof buffer, id, (void*)buffer);
		sts |= (buffer[2]&0xf)<<8;		/* sense key ݒ */
	}
	return sts;
}


/*{
y֐z
	struct _readcap*	scsi_read_capacity(int id)

yz
	id		ǂݏo SCSI foCX ID

y@\z
	id  SCSI foCXAstruct _readcap 擾

y߂z
	ɓǂݍ߂ꍇ struct _readcap ւ̃|C^
	ǂݍ݂Ɏsꍇ NULL

}*/
struct _readcap*	scsi_read_capacity(int id)
{
	int sts;
	static struct _readcap cap;

	if ((sts = ck_scsi_readcap(id, &cap)) < 0) return NULL;

	if (sts & SCSI_STS_CHKCOND) {
		if (ck_scsi_readcap(id, &cap) & SCSI_STS_CHKCOND) return NULL;
	}

	/* 256:0, 512:1, 1024:2 */
	scsi_sector_type  = cap.size >> 9;
	scsi_sector_count = 1024 / cap.size;
	return &cap;
}


/*{
y֐z
	int	scsi_read_sector(int id, void* buffer, int sectno)

yz
	id		ǂݏo SCSI foCX ID
	buffer	ǂݍ񂾃f[^i[obt@
	sectno	ǂݏo_ZN^ԍ

y@\z
	id  SCSI foCXA_ZN^ sectno  buffer ɓǂݍށB

y߂z
	ɓǂݍ߂ꍇ 0
	ǂݍ݂Ɏsꍇ < 0

}*/
int	scsi_read_sector(int id, void* buffer, int sectno)
{
	if (scsi_read_capacity(id) == NULL) return -1;
	return _scsi_readext(sectno*scsi_sector_count, scsi_sector_count,
	                     id, scsi_sector_type, buffer);
}


/*{
y֐z
	int	scsi_write_sector(int id, void* buffer, int sectno)

yz
	id		 SCSI foCX ID
	buffer	ރf[^i[obt@
	sectno	ޘ_ZN^ԍ

y@\z
	buffer ̓eAid SCSI foCX̘_ZN^ sectno ɏށB

y߂z
	ɏ߂ꍇ 0
	݂Ɏsꍇ < 0

}*/
int	scsi_write_sector(int id, void* buffer, int sectno)
{
	if (scsi_read_capacity(id) == NULL) return -1;
	return _scsi_writeext(sectno*scsi_sector_count, scsi_sector_count,
	                     id, scsi_sector_type, buffer);
}


/*{
y֐z
	int	scsi_readext(int id, void* buffer, int sectno, int sectcnt)

yz
	id		ǂݏo SCSI foCX ID
	buffer	ǂݍ񂾃f[^i[obt@
	sectno	ǂݏo_ZN^ԍ
	sectcnt	ǂݏo_ZN^

y@\z
	id  SCSI foCXA_ZN^ԍ sectno  sectcnt 
	buffer ɓǂݍށB

y߂z
	ɓǂݍ߂ꍇ 0
	ǂݍ݂Ɏsꍇ < 0

yӁz
	sɐ旧 scsi_read_capacity() ĂяoĂ

}*/
int	scsi_readext(int id, void* buffer, int sectno, int sectcnt)
{
#if	0
	/* Ăяô͌̂ŎOɌĂяoĂ */
	if (scsi_read_capacity(id) == NULL) return -1;
#endif
	return _scsi_readext(sectno*scsi_sector_count, sectcnt*scsi_sector_count,
	                     id, scsi_sector_type, buffer);
}


/*{
y֐z
	int	scsi_write_sector(int id, void* buffer, int sectno, int sectcnt)

yz
	id		 SCSI foCX ID
	buffer	ރf[^i[obt@
	sectno	ޘ_ZN^ԍ
	sectcnt	ޘ_ZN^
	
y@\z
	buffer ̓eAid SCSI foCX̘_ZN^ԍ sectno 
	sectcnt ZN^ށB

y߂z
	ɏ߂ꍇ 0
	݂Ɏsꍇ < 0

yӁz
	sɐ旧 scsi_read_capacity() ĂяoĂ

}*/
int	scsi_writeext(int id, void* buffer, int sectno, int sectcnt)
{
#if	0
	/* Ăяô͌̂ŎOɌĂяoĂ */
	if (scsi_read_capacity(id) == NULL) return -1;
#endif
	return _scsi_writeext(sectno*scsi_sector_count, sectcnt*scsi_sector_count,
	                     id, scsi_sector_type, buffer);
}


