#include <stdio.h>
#include <stdlib.h>
#include <sys/iocs.h>
#include "scsipart.h"

#define	uch	unsigned char
#define	ull	unsigned long long
#define	_isdigit(c)	((uch)'0'<=(uch)(c)&&(uch)(c)<=(uch)'9')
#define	_isprint(c)	((uch)0x20<=(uch)(c)&&(uch)(c)<(uch)0x7f)

/* scsi board id */
int board_id = 7;
int scsi_available[8];

static int scsi_check(void)
{
  int id;
  uch buf[36];

  if (!scsi_available()) {
    fprintf(stderr, "SCSI hCogݍ܂Ă܂\n");
    return -1;
  }
  board_id = scsi_boardid();
  printf("SCSI foCX`FbN "), fflush(stdout);
  for (id = 0; id < 8; id++) {
    if (id == board_id || ck_scsi_testunit(id) < 0
    ||  ck_scsi_inquiry(sizeof buf, id, (struct _inquiry*)buf) != 0
    ||  (buf[0] != 0x00 && buf[0] != 0x7 && buf[0] != 0x84)) {
      scsi_available[id] = 0;
      putchar(id == board_id ? 'b' : 'x'), fflush(stdout);
    }
    else {
      scsi_available[id] = 1;
      putchar(id + '0'), fflush(stdout);
    }
  }
  printf(" I\n"), fflush(stdout);
  return 0;
}


static void disp_inquiry(int id)
{
  int i, lim;
  uch buf[36];

  if (ck_scsi_inquiry(sizeof buf, id, (struct _inquiry*)buf) == 0) {
    lim = min(buf[4] + 5, sizeof buf);
    for (i = 8; i < lim; i++) {
      if (_isprint(buf[i])) fputc(buf[i], stdout);
    }
    fputc('\n', stdout);
  }
}


static void disp_scsi(void)
{
  int id;
  struct _readcap* cp;

  printf("\nid size   total   inquiry\n"
           "-- ---- --------- ----------------------------\n");
  for (id = 0; id < 8; id++) {
    if (scsi_available[id]) {
      cp = scsi_read_capacity(id);
      if (cp) {
        printf("%2d %4d %8dK ", id, cp->size, (int)(((ull)cp->block*(ull)cp->size)/1024UL));
      }
      else {
        printf("%2d **** ********K ", id);
      }
      disp_inquiry(id);
    }
  }
}

static int submenu(void)
{
  int cmd;

  while(1) {
    cmd = inputc("\n1:̈m 2:̈ 3:ύX 4:OSύX 5:img 6:imgo 7:imgNA 9:߂ -->");
    if (cmd == '.' || _isdigit(cmd)) break;
    fprintf(stderr, "w肪Ⴂ܂.\n");
  }
  fputc('\n', stdout);
  return cmd - '0';
}

int main(void)
{
  int id;

  if (scsi_check() < 0) return -1;

  while (1) {
    do {
      disp_scsi();
      id = inputc("\nSCSI-ID(0-7) w肵ĉ(I:Q)-->");
      id -= '0';
      fflush(stdout);
    } while ((unsigned)id > 7U);

    if (id == board_id) {
      fprintf(stderr, "ID%d  SCSI I/F {[hł.\n", id);
      continue;
    }

    if (getpart(id) < 0) continue;
    disppart(id);
    switch(submenu())
      {
      case 1:
        makepart(id);
        break;
      case 2:
        relpart(id);
        break;
      case 3:
        change_attr(id);
        break;
      case 4:
        change_name(id);
        break;
      case 5:
        image_put(id);
        break;
      case 6:
        image_get(id);
        break;
      case 7:
        image_clear(id);
        break;
      case -1:
        return 0;
      default:
        break;
      }
  }
  return 0;
}
