#ifndef	__scsipart_h__
#define	__scsipart_h__	1

#include <sys/scsi.h>

#ifdef	HAVE_IPRINT_H
#define	CALL_IPRINT_ALL
#include "iprint.h"
#endif

#ifndef	max
#define	max(a,b)	((a)>(b)?(a):(b))
#endif

#ifndef	min
#define	min(a,b)	((a)<(b)?(a):(b))
#endif

typedef	unsigned char	uchar_t;
typedef	unsigned short	ushort_t;
typedef	unsigned int	uint_t;
typedef	unsigned long	ulong_t;

#define	PNAM_MAX	(8)			/* human68k p[eBVő咷 */
#define	PID_LEN		(4)			/* p[eBVhc */
#define	PID_STR		"X68K"		/* p[eBVhc */
#define	PCNT_MAX	(15)		/* human68k p[eBVől */
#define	LOGSEC_LEN	(1024)		/* human68k ̘_ZN^ */
#define	SKIP_SECT	(0x20UL)	/* humna68k XLbvZN^ */
#define	MB_MASK		(~0x3ffUL)	/*  FORMAT.X  MB Pʂŗ̈mۂ */

typedef	struct	{
	uchar_t	name[PNAM_MAX];	/* p[eBV */
	uint_t	flag:8;			/* p[eBVgp󋵃tO(0:N, 1:gps, 2:gp\ */
	uint_t	start:24;		/* p[eBVJn_ZN^ԍ */
	ulong_t	count;			/* p[eBV_ZN^ */
}	pent_s;

typedef	struct	{
	uchar_t	pid[PID_LEN];	/* p[eBVhc "X68K" */
	ulong_t	used;			/* (mۍςݗ̈{P)_ZN^ԍ */
	ulong_t	total;			/* p\S_ZN^ */
	ulong_t	total2;			/* p\S_ZN^(\) */
	pent_s	ent[PCNT_MAX];	/* p[eBV */
}	ptab_s;

extern ptab_s parttab;

#define SCSI_B256  0
#define SCSI_B512  1
#define SCSI_B1024 2


/* 1024 ̔{ */
#define RWSIZ	(512*1024)
extern char rwbuf[RWSIZ];


#define PART_SECTNO		2	/* p[eBVe[u_ZN^ԍ */
#define	SCSI_STS_CHKCOND	(0x02)

#define	partname(no)		((no)+'a'+((no)<2?0:1))
#define	partnumber(name)	((name)-'a'-((name)>'c'?1:0))

extern int  board_id;
extern int  scsi_available[8];
extern ulong_t max_freeblock;
extern ulong_t used_capacity;
extern ulong_t free_capacity;
extern ulong_t total_capacity;

extern uchar_t sectbuf[];

extern int  countpart(void);
extern int  testunit(int id);
extern int  getpart(int id);
extern int  putpart(int id);
extern void disppart(int id);
extern void makepart(int id);
extern void relpart(int id);
extern void change_attr(int id);
extern void change_name(int id);
extern void print_guide(char* str, int sectcnt);
extern void image_get(int id);
extern void image_put(int id);
extern void image_clear(int id);

extern char*input(char* fmt, ...);
extern int  inputc(char* fmt, ...);

#define	scsi_available()	(_iocs_b_bpeek((const void*)0xed006f)==0x56)
#define	scsi_boardid()		(_iocs_b_bpeek((const void*)0xed0070)&7)
#define	scsi_boardtype()	(_iocs_b_bpeek((const void*)0xed0070)&8)

/*	scsilib.c	*/
extern int  scsi_sector_type;
extern int  scsi_sector_count;

extern int  ck_scsi_testunit(int id);
extern int  ck_scsi_inquiry(int inqsiz, int id, struct _inquiry* inqptr);
extern int  ck_scsi_readcap(int id, struct _readcap* inqptr);
extern struct _readcap*	scsi_read_capacity(int id);
extern int	scsi_read_sector(int id, void* buffer, int sectno);
extern int	scsi_write_sector(int id, void* buffer, int sectno);
extern int	scsi_readext(int id, void* buffer, int sectno, int sectcnt);
extern int	scsi_writeext(int id, void* buffer, int sectno, int sectcnt);

#endif	__scsipart_h__
